package com.yeejoin.amos.boot.module.jg.biz.edit.process.biz.overDesign;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.yeejoin.amos.boot.biz.common.entity.BaseEntity;
import com.yeejoin.amos.boot.module.common.biz.event.CommonPublisher;
import com.yeejoin.amos.boot.module.jg.api.dto.FieldChangeMeta;
import com.yeejoin.amos.boot.module.jg.api.dto.PipelineChangeItemDto;
import com.yeejoin.amos.boot.module.jg.api.entity.JgOverDesignServiceLife;
import com.yeejoin.amos.boot.module.jg.api.enums.BusinessTypeEnum;
import com.yeejoin.amos.boot.module.jg.biz.edit.event.BaseBizDataChangeEvent;
import com.yeejoin.amos.boot.module.jg.biz.edit.process.biz.DefaultBizDataChangeHandler;
import com.yeejoin.amos.boot.module.ymt.api.enums.FlowStatusEnum;
import org.springframework.context.ApplicationContext;
import org.springframework.stereotype.Component;

import java.util.*;

/**
 * 设备停用启用编辑处理器
 */
@Component
public class OverDesignDataChangeHandler extends DefaultBizDataChangeHandler<BaseBizDataChangeEvent> {

    private final OverDesignEditUpdateService overDesignEditUpdateService;

    protected OverDesignDataChangeHandler(CommonPublisher routerEventPublisher, ApplicationContext applicationContext, OverDesignEditUpdateService overDesignEditUpdateService) {
        super(routerEventPublisher, applicationContext);
        this.overDesignEditUpdateService = overDesignEditUpdateService;
    }

    @Override
    public String canHandleBizType() {
        return BusinessTypeEnum.JG_OVER_DESIGN_SERVICE_LIFE.name();
    }

    @Override
    public List<FieldChangeMeta> postSave(String bizId, String applyNo, ModelType model, Map<String, Object> changeData, List<FieldChangeMeta> allChangeColumns, Map<String, List<PipelineChangeItemDto>> pipelineChangeItemMap) {
        return Collections.emptyList();
    }

    @Override
    public Boolean beforeCheck(String bizId, String applyNo, ModelType model, Map<String, Object> changeData) {
        return Boolean.TRUE;
    }

    @Override
    public Set<String> getEqs(String applyNo) {
        return overDesignEditUpdateService.getEqsByApplyNo(applyNo);
    }

    /**
     * 管道专用-判断数据是实时落库，还是先存到json
     *
     * @param applyNo 单据号
     * @return 是否需要临时存储
     */
    @Override
    public Boolean requiresTemporarySave(String applyNo) {
        return false;
    }

    @Override
    public Boolean bizIsFinished(String applyNo) {
        JgOverDesignServiceLife overDesignServiceLife = overDesignEditUpdateService.getOverDesignServiceLifeService().getOne(new LambdaQueryWrapper<JgOverDesignServiceLife>().eq(JgOverDesignServiceLife::getApplyNo, applyNo).select(BaseEntity::getSequenceNbr, JgOverDesignServiceLife::getStatus));
        return overDesignServiceLife.getStatus().equals(FlowStatusEnum.TO_BE_FINISHED.getName());
    }

    @Override
    public Set<String> getProjectContraptionIds(String applyNo) {
        return new HashSet<>();
    }

    @Override
    public void preSave(String bizId, String applyNo, ModelType model, Map<String, Object> changeData) {

    }
}
